program CK4Patch;

{$A+,B+,E-,F-,G-,I-,P+,Q-,R-,S-,T-,V-,X+}
{$M 3072,0,0}

{$DEFINE KEEN4}
{$DEFINE KEEN4_ARCH}

uses Loader,Parser,Patcher,Misc,Dos,Strings;

const
    ExecutableFileSpec='KEEN4*.EXE';
    ProgramName='CK4PATCH';
    Ext='CK4';
    NumLevels=18;

type
    TDataFile=(dfGameMaps,dfEGAGraph,dfAudio);
    TDataResource=(drAudioHed,drEGAHead,drMapHead,drAudioDct,drEGADict);

    PDataResourceOffset=^TDataResourceOffset;
    TDataResourceOffset=array[Low(TDataResource)..High(TDataResource)] of Longint;

    PLevelStringLength=^TLevelStringLength;
    TLevelStringLength=array[0..NumLevels] of Word;

    PLevelHintOffset=^TLevelHintOffset;
    TLevelHintOffset=array[0..1] of Longint;

    PLevelHintLength=^TLevelHintLength;
    TLevelHintLength=array[0..1] of Word;

    PVersion=^TVersion;
    TVersion=record
        ID:String[7];
        ImageLength:Longint;
        DataResourceOffset:PDataResourceOffset;
        LevelNameOffset:Longint;
        LevelNameLength:PLevelStringLength;
        LevelEntryOffset:Longint;
        LevelEntryLength:PLevelStringLength;
        LevelHintOffset:PLevelHintOffset;
        LevelHintLength:PLevelHintLength;
    end;

const
    LevelHintMap:array[0..NumLevels] of Byte=
        ($FF,$FF,$FF,$FF,$FF,0,$FF,1,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF);

    DataResourceOffset_14:TDataResourceOffset=
        ($20DE8,$21080,$24830,$344F6,$358F6);

    LevelNameLength_14:TLevelStringLength=
        (16,16,16,32,32,16,16,16,16,16,16,32,32,48,32,16,16,16,32);

    LevelEntryLength_14:TLevelStringLength=
        (32,48,32,48,64,48,48,32,48,32,48,48,48,64,64,48,48,48,64);

    LevelHintOffset_14:TLevelHintOffset=($30999,$3094C);
    LevelHintLength_14:TLevelHintLength=(74,77);

    Version:array[0..0] of TVersion=(
        (
            ID:'1.4';
            ImageLength:251712;
            DataResourceOffset:@DataResourceOffset_14;
            LevelNameOffset:$1F040;
            LevelNameLength:@LevelNameLength_14;
            LevelEntryOffset:$1F1F0;
            LevelEntryLength:@LevelEntryLength_14;
            LevelHintOffset:@LevelHintOffset_14;
            LevelHintLength:@LevelHintLength_14
        ));

{$I CKXPATCH.INC}

begin
    Main;
end.
