program CK6Patch;

{$A+,B+,E-,F-,G-,I-,P+,Q-,R-,S-,T-,V-,X+}
{$M 3072,0,0}

{$DEFINE KEEN6}
{$DEFINE KEEN4_ARCH}

uses Loader,Parser,Patcher,Misc,Dos,Strings;

const
    ExecutableFileSpec='KEEN6*.EXE';
    ProgramName='CK6PATCH';
    Ext='CK6';
    NumLevels=18;

type
    TDataFile=(dfGameMaps,dfEGAGraph,dfAudio);
    TDataResource=(drAudioHed,drEGAHead,drMapHead,drAudioDct,drEGADict);

    PDataResourceOffset=^TDataResourceOffset;
    TDataResourceOffset=array[Low(TDataResource)..High(TDataResource)] of Longint;

    PLevelStringLength=^TLevelStringLength;
    TLevelStringLength=array[0..NumLevels] of Word;

    PVersion=^TVersion;
    TVersion=record
        ID:String[7];
        ImageLength:Longint;
        DataResourceOffset:PDataResourceOffset;
        LevelNameOffset:Longint;
        LevelNameLength:PLevelStringLength;
        LevelEntryOffset:Longint;
        LevelEntryLength:PLevelStringLength;
    end;

const
    DataResourceOffset_10:TDataResourceOffset=
        ($1F820,$1FB20,$23C50,$35912,$35D12);

    DataResourceOffset_14:TDataResourceOffset=
        ($20C50,$20F50,$25080,$36EEE,$372EE);

    LevelNameLength_10:TLevelStringLength=
        (16,32,16,32,32,16,32,16,32,16,16,16,32,32,32,32,16,32,16);

    LevelEntryLength_10:TLevelStringLength=
        (32,48,48,48,48,48,48,32,48,48,48,80,48,64,64,64,48,48,48);

    Version:array[0..1] of TVersion=(
        (
            ID:'1.0';
            ImageLength:254768;
            DataResourceOffset:@DataResourceOffset_10;
            LevelNameOffset:$1DA70;
            LevelNameLength:@LevelNameLength_10;
            LevelEntryOffset:$1DC40;
            LevelEntryLength:@LevelEntryLength_10
        ),(
            ID:'1.4';
            ImageLength:260432;
            DataResourceOffset:@DataResourceOffset_14;
            LevelNameOffset:$1EF40;
            LevelNameLength:@LevelNameLength_10;
            LevelEntryOffset:$1F110;
            LevelEntryLength:@LevelEntryLength_10

        ));

{$I CKXPATCH.INC}

begin
    Main;
end.
