global Int21HandlerInit
global Int21HandlerRun
global Int21HandlerDone

extern GetIntVec
extern SetIntVec
extern RedirectFile

True equ 1
False equ 0

segment CODE

Int21Handler:
; Check if requesting 'Open file or device' service
    CMP AH,0x3D
    JNE PassThrough

; Check if we're supposed to be redirecting files yet
    CMP BYTE [CS:RedirectEnabled],True
    JNE PassThrough

; Call DOS with DS:DX adjusted to point to redirected file, return results
Redirect:
    PUSH DS
    PUSH DX
    PUSH ES
    PUSH DI
    PUSH SI
    PUSH CX
    PUSH BX
    PUSH AX

    PUSH DS
    PUSH DX
    MOV AX,DATA
    MOV DS,AX
    CALL RedirectFile

    MOV DS,DX
    MOV DX,AX
    POP AX
    POP BX
    POP CX
    POP SI
    POP DI
    POP ES

    PUSHF
    CLI
    CALL FAR [CS:PrevInt21Handler]
    STI

    POP DX
    POP DS
    RETF 2

; Pass request through to DOS
PassThrough:
    JMP FAR [CS:PrevInt21Handler]

Int21HandlerInit:
    MOV AX,0x21
    PUSH AX
    MOV AX,SEG PrevInt21Handler
    PUSH AX
    MOV AX,PrevInt21Handler
    PUSH AX
    CALL FAR GetIntVec

    MOV AX,0x21
    PUSH AX
    MOV AX,SEG Int21Handler
    PUSH AX
    MOV AX,Int21Handler
    PUSH AX
    CALL FAR SetIntVec

    RET

Int21HandlerRun:
    MOV BYTE [CS:RedirectEnabled],True
    RET

Int21HandlerDone:
    MOV AX,0x21
    PUSH AX
    PUSH WORD [CS:PrevInt21Handler+2]
    PUSH WORD [CS:PrevInt21Handler]
    CALL FAR SetIntVec
    RET

PrevInt21Handler: dd 0
RedirectEnabled: db False

segment DATA
